routes/web.php
<?php

use App\Http\Controllers\Contracts\ContractController;
use App\Http\Controllers\Estimates\EstimateController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\Roles\RoleController;
use App\Http\Controllers\Services\ServiceController;
use App\Http\Controllers\SubTours\SubTourController;
use App\Http\Controllers\Tours\TourController;
use App\Http\Controllers\Users\UserController;
use App\Http\Controllers\Commissions\CommissionController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect('login');
});

Auth::routes();

Route::get('/home', [HomeController::class, 'index'])
    ->name('home')
    ->middleware('auth');

Route::group(['middleware' => 'auth'], function() {
    Route::name('tours.')->prefix('tours')->group(function () {
        Route::get('/', [TourController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:tour-list');
        Route::get('/create', [TourController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:tour-create');
        Route::post('/', [TourController::class, 'store'])
            ->name('store')
            ->middleware('has_permission:tour-create');
        Route::get('/edit/{id}', [TourController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:tour-edit');
        Route::put('/{id}', [TourController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:tour-edit');
        Route::delete('/{id}', [TourController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:tour-delete');
        Route::get('/show/{id}', [TourController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:tour-list');
        Route::get('/search', [TourController::class, 'search'])
            ->name('search');
    });
    Route::name('users.')->prefix('users')->group(function () {
        Route::get('/', [UserController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:user-list');
        Route::get('/create', [UserController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:user-create');
        Route::post('/', [UserController::class, 'store'])
            ->name('store')
            ->middleware('has_permission:user-create');
        Route::get('/edit/{id}', [UserController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:user-edit');
        Route::put('/{id}', [UserController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:user-edit');
        Route::delete('/{id}', [UserController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:user-delete');
        Route::get('/show/{id}', [UserController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:user-list');
        Route::get('/search', [UserController::class, 'search'])
            ->name('search');
    });
    Route::name('services.')->prefix('services')->group(function () {
        Route::get('/', [ServiceController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:service-list');
        Route::get('/create', [ServiceController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:service-create');
        Route::post('/', [ServiceController::class, 'store'])
            ->name('store')
            ->middleware('has_permission:service-create');
        Route::get('/edit/{id}', [ServiceController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:service-edit');
        Route::put('/{id}', [ServiceController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:service-edit');
        Route::delete('/{id}', [ServiceController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:service-delete');
        Route::get('/show/{id}', [ServiceController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:service-list');
    });
    Route::name('roles.')->prefix('roles')->group(function () {
        Route::get('/', [RoleController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:role-list');
        Route::get('/create', [RoleController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:role-create');
        Route::post('/', [RoleController::class, 'store'])
            ->name('store')
            ->middleware('has_permission:role-create');
        Route::get('/edit/{id}', [RoleController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:role-edit');
        Route::put('/{id}', [RoleController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:role-edit');
        Route::delete('/{id}', [RoleController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:role-delete');
        Route::get('/show/{id}', [RoleController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:role-list');
        Route::get('/search', [RoleController::class, 'search'])
            ->name('search');
    });
    Route::name('subTours.')->prefix('subTours')->group(function () {
        Route::get('/', [SubTourController::class, 'index'])
            ->name('index');
        Route::get('/create', [SubTourController::class, 'create'])
            ->name('create');
        Route::post('/', [SubTourController::class, 'store'])
            ->name('store');
        Route::get('/edit/{id}', [SubTourController::class, 'edit'])
            ->name('edit');
        Route::put('/{id}', [SubTourController::class, 'update'])
            ->name('update');
        Route::delete('/{id}', [SubTourController::class, 'destroy'])
            ->name('destroy');
        Route::get('/show/{id}', [SubTourController::class, 'show'])
            ->name('show');
        Route::get('/search', [SubTourController::class, 'search'])
            ->name('search');
    });

    Route::name('estimates.')->prefix('estimates')->group(function () {
        Route::get('subTour/{subTourId}', [EstimateController::class, 'index'])
            ->name('index');
        Route::get('/create', [EstimateController::class, 'create'])
            ->name('create');
        Route::post('/', [EstimateController::class, 'store'])
            ->name('store');
        Route::get('/edit/{id}', [EstimateController::class, 'edit'])
            ->name('edit');
        Route::put('/{id}', [EstimateController::class, 'update'])
            ->name('update');
        Route::delete('/{id}', [EstimateController::class, 'destroy'])
            ->name('destroy');
        Route::get('/show/{id}', [EstimateController::class, 'show'])
            ->name('show');
        Route::get('/search', [EstimateController::class, 'search'])
            ->name('search');
        Route::get('/export/{id}', [EstimateController::class, "export"])
            ->name("export");
    });

    Route::name('contracts.')->prefix('contracts')->group(function () {
        Route::get('subTour/{subTourId}', [ContractController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:contract-list');
        Route::get('subTour/{subTourId}/create', [ContractController::class, 'create'])
            ->name('create')
            ->middleware('has_permission:contract-create');
        Route::post('/', [ContractController::class, 'store'])
            ->name('store');
        Route::get('/edit/{id}', [ContractController::class, 'edit'])
            ->name('edit')
            ->middleware('has_permission:contract-edit');
        Route::put('/{id}', [ContractController::class, 'update'])
            ->name('update')
            ->middleware('has_permission:contract-edit');
        Route::delete('/{id}', [ContractController::class, 'destroy'])
            ->name('destroy')
            ->middleware('has_permission:contract-delete');
        Route::get('/show/{id}', [ContractController::class, 'show'])
            ->name('show')
            ->middleware('has_permission:contract-list');
        Route::get('/search', [ContractController::class, 'search'])
            ->name('search');
        Route::get('/createContract/{id}', [ContractController::class, "createContractFile"])
            ->name("createContractFile");
        Route::get('/contract/{contractId}/history', [ContractController::class, "history"])
            ->name("history");
    });
    Route::name('commissions.')->prefix('commissions')->group(function () {
        Route::get('contract/{contractId}', [CommissionController::class, 'index'])
            ->name('index')
            ->middleware('has_permission:contract-list');
        Route::get('contract/{contractId}/create', [CommissionController::class, 'create'])
            ->name('create');
        Route::post('/', [CommissionController::class, 'store'])
            ->name('store');
        Route::get('/edit/{id}', [CommissionController::class, 'edit'])
            ->name('edit');
        Route::put('/{id}', [CommissionController::class, 'update'])
            ->name('update');
        Route::delete('/{id}', [CommissionController::class, 'destroy'])
            ->name('destroy');

app/Models/Role.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;

class Role extends \Spatie\Permission\Models\Role
{
    use HasFactory;

    protected $hidden = ['guard_name', 'pivot'];

    public function scopeSearchByRole($query, $roleName)
    {
        return $roleName ? $query->where('name', 'LIKE', '%' . $roleName . '%') : null;
    }

    public function setGuardNameAttribute($value): string
    {
        return $this->attributes['guard_name'] = 'web';
    }

    public function getRolePermissionId($id)
    {
        return $this->permissions()->where('role_id', $id)->pluck('permission_id');
    }

    public function search($key)
    {
        return Role::where('name', 'LIKE', '%' . $key. '%')->latest('id')->paginate(5);
    }
}

app/Http/Controllers/Roles/RoleController.php
<?php

namespace App\Http\Controllers\Roles;

use App\Http\Controllers\Controller;
use App\Models\Role;
use App\Services\PermissionService;
use App\Services\RoleService;
use Illuminate\Http\Request;

class RoleController extends Controller
{

    protected $roleService;
    protected $permissionService;
    protected $role;

    public function __construct(RoleService $roleService, PermissionService $permissionService, Role $role)
    {
        $this->roleService = $roleService;
        $this->permissionService = $permissionService;
        $this->role = $role;
    }

    public function index()
    {
        $roles = $this->roleService->index();
        return view('admin.roles.index', compact('roles'));
    }

    public function create()
    {
        $permissions = $this->permissionService->getAllPermission();
        $permissionGroups = $this->permissionService->getGroupsPermission();
        return view('admin.roles.create', compact('permissions', 'permissionGroups'));
    }

    public function store(Request $request)
    {
        $this->roleService->store($request);
        return redirect()->route('roles.index');
    }

    public function show($id)
    {
        $role = $this->roleService->show($id);
        return view('admin.roles.show', compact('role'));
    }

    public function edit($id)
    {
        $role = $this->roleService->findById($id);
        $permissions = $this->permissionService->getAllPermission();
        $permissionIds = $this->roleService->getRolePermissionId($id);
        $permissionGroups = $this->permissionService->getGroupsPermission();
        return view('admin.roles.edit', compact('role', 'permissions', 'permissionIds', 'permissionGroups'));
    }

    public function update(Request $request, $id)
    {
        $this->roleService->update($request, $id);
        return redirect()->route('roles.index');
    }

    public function destroy($id)
    {
        $this->roleService->destroy($id);
        return redirect()->route('roles.index');
    }

    public function search(Request $request)
    {
        $key = $request->input('key') ?? '';
        $result = $this->role->search($key);
        return view('admin.roles.index', ['roles' => $result]);
    }
}

resources/views/admin/roles/create.blade.php
@extends('admin.layouts.app')

@section('title')
    <title>Create Role</title>
@endsection

@section('content')
    <div id="layoutSidenav_content">
        <main>
            <div class="container-fluid px-4">
                <h1 class="mt-4">Create Role</h1>
                <ol class="breadcrumb mb-4">
                    <a class="breadcrumb-item active" href="{{ url()->previous() }}">Back>></a>
                </ol>
                <div class="container">
                    <div class="row justify-content-center">
                        <form action="{{ route('roles.store') }}" method="POST">
                            @csrf
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Name</label>
                                    <input name="name" type="text" class="form-control" placeholder="Name...">
                                </div>
                            </div>

                            <label class="form-label">Permission</label>
                            <div class="mb-3">
                                <input class="form-check-input" type="checkbox" id="checkAll">
                                <label class="form-label">Select All</label>
                                <div class="row ">
                                    @foreach($permissionGroups as $group => $permission)
                                        <div class="col-md-3 mt-3">
                                            <input class="form-check-input select-item" type="checkbox" id="{{ $group }}" />
                                            <label class="form-label" type="checkbox" ><b>{{ $group }}</b></label>
                                            @foreach($permission as $permissionItem)
                                                <div class="card-text">
                                                    <div class="form-check">
                                                        <input class="form-check-input" type="checkbox"
                                                               name="permission[]"
                                                               id="{{ $permissionItem->name }}"
                                                               value="{{ $permissionItem->name }}">
                                                        <label class="form-check-label" for="flexCheckDefault">
                                                            {{ $permissionItem->name }}
                                                        </label>
                                                    </div>
                                                </div>
                                            @endforeach
                                        </div>
                                    @endforeach
                                </div>
                            </div>
                            <button type="submit" class="btn btn-success">Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </main>
    </div>
    <script>
        $("#checkAll").click(function () {
            $('input:checkbox').not(this).prop('checked', this.checked);
        });
    </script>
@endsection

@section('js')
    <script defer src="{{ asset('js/create-role.js') }}"></script>
@endsection

resources/views/admin/roles/edit.blade.php
@extends('admin.layouts.app')

@section('title')
    <title>Update Role</title>
@endsection

@section('content')
    <div id="layoutSidenav_content">
        <main>
            <div class="container-fluid px-4">
                <h1 class="mt-4">Update Role</h1>
                <ol class="breadcrumb mb-4">
                    <a class="breadcrumb-item active" href="{{ url()->previous() }}">Back>></a>
                </ol>
                <div class="container">
                    <div class="row justify-content-center">
                        <form action="{{route('roles.update', $role->id)}}" method="POST">
                            @csrf
                            @method('PUT')
                            <div class="mb-3">
                                <div class="form-group">
                                    <label class="form-label">Name</label>
                                    <input name="name" type="text" class="form-control"
                                           placeholder="Name..." value="{{$role->name}}">
                                </div>
                            </div>
                            <label class="form-label">Permission</label>
                            <div class="mb-3">
                                <input class="form-check-input" type="checkbox" id="checkAll">
                                <label class="form-label">Select All</label>
                                <div class="row ">
                                    @foreach($permissionGroups as $group => $permission)
                                        <div class="col-md-3 mt-3">
                                            <input class="form-check-input select-item" type="checkbox">
                                            <label class="form-label" type="checkbox" ><b>{{ $group }}</b></label>
                                            @foreach($permission as $permissionItem)
                                                <div class="card-text">
                                                    <div class="form-check">
                                                        <input {{$permissionIds->contains($permissionItem->id) ? 'checked' : ''}} class="form-check-input" type="checkbox"
                                                               name="permission[]"
                                                               value="{{ $permissionItem->id }}">
                                                        <label class="form-check-label" for="flexCheckDefault">
                                                            {{ $permissionItem->name }}
                                                        </label>
                                                    </div>
                                                </div>
                                            @endforeach
                                        </div>
                                    @endforeach
                                </div>
                            </div>
                            <button type="submit" class="btn btn-success" >Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </main>
    </div>
    <script>
        $("#checkAll").click(function () {
            $('input:checkbox').not(this).prop('checked', this.checked);
        });
    </script>
@endsection

resources/views/admin/roles/index.blade.php
@extends('admin.layouts.app')

@section('title')
    <title>Role Management</title>
@endsection

@section('content')
    <div id="layoutSidenav_content">
        <main>
            <div class="container-fluid px-4">
                <h1 class="mt-4">Role Management</h1>
                <ol class="breadcrumb mb-4">
                    <a class="breadcrumb-item active" href="{{ route('home') }}">HomePage</a>
                </ol>
                <div class="row mt-5">
                    <form action="{{route('roles.search')}}" class="input-group col-9" method="GET" style="margin-left: 9%">
                        <input type="search" class="form-control rounded col-5" placeholder="Search" name="key" />
                        <button type="submit" class="btn btn-outline-primary ml-2 col-1">search</button>
                    </form>
                    <div class="col-2" style="margin-left: -1%">
                        <a href="{{ route('roles.create') }}" class="btn btn-success col-5">
                            <i class="fas fa-plus-circle"></i>&nbsp;Create
                        </a>
                    </div>
                </div>
            </div>
            <div class="d-flex justify-content-center">
                <table class="table table-bordered mt-5" style="width: 80% !important;">
                <thead>
                    <tr align="center">
                        <th scope="col">Order</th>
                        <th scope="col">Role</th>
                        <th scope="col" style="width: 60% !important;">Permission</th>
                        <th scope="col">Action</th>
                    </tr>
                </thead>
                <tbody align="center">
                @foreach($roles as $key => $role)
                    <tr>
                        <td scope="row">{{$key+1}}</td>
                        <td scope="row">{{$role->name}}</td>
                        @if ($role->name === 'director')
                            <td>
                                <b style="font-size: 18px !important;">All permissions.</b>
                            </td>
                        @elseif ($role->name === 'customer')
                            <td>
                                <b style="font-size: 18px !important;">No any permission.</b>
                            </td>
                        @else
                            <td>
                                @foreach($role->permissions as $permission)
                                    <span class="badge badge-light" style="font-size:18px !important;">{{$permission->name}}</span>
                                @endforeach
                            </td>
                        @endif
                        <td style="text-align: center">
                            <a href="{{route('roles.edit', $role->id)}}" class="btn btn-success"><i
                                    class="far fa-edit"></i></a>
                            <button type="submit" class="btn btn-danger btn-delete" onclick="deleteRole({{$role->id}})"><i
                                    class="fas fa-trash-alt"></i></button>
                            <form action="{{route('roles.destroy', $role->id)}}" id="form-{{$role->id}}" method="POST">
                                @method('DELETE')
                                @csrf
                            </form>
                        </td>
                    </tr>
                @endforeach
                </tbody>
            </table>
            </div>
            <div class="container-fluid" style="display: flex; justify-content: end; margin-left: -9%;">
                {{$roles->links()}}
            </div>
@endsection

@push('scripts')
    <script>
        function deleteRole(id)
        {
            Swal.fire({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                icon: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
            }).then((result) => {
                if (result.isConfirmed) {
                    event.preventDefault();
                    document.getElementById('form-' + id).submit();
                    Swal.fire(
                        'Deleted!',
                        'Your file has been deleted.',
                        'success'
                    )
                }
            })
        }
    </script>
@endpush